# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Summary:	Transparently store multi-level data in DBM
Name:		perl-MLDBM
Version:	2.05
Release:	29.%{__distinit}%{__distvers}
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/MLDBM
Source0:	https://cpan.metacpan.org/authors/id/C/CH/CHORNY/MLDBM-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	sed
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(Data::Dumper) >= 2.08
BuildRequires:	perl(FreezeThaw)
BuildRequires:	perl(Storable)
BuildRequires:	perl(strict)
BuildRequires:	perl(Tie::Hash)
BuildRequires:	perl(vars)
# Test Suite
BuildRequires:	perl(Fcntl)
BuildRequires:	perl(Test::More)
# Optional Tests
BuildRequires:	perl(DB_File)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif

%description
This module can serve as a transparent interface to any TIEHASH package that is
required to store arbitrary perl data, including nested references. Thus, this
module can be used for storing references and other arbitrary data within DBM
databases.

%prep
%setup -q -n MLDBM-%{version}

# Fix line endings for documentation
sed -i -e 's/\r$//' README Changes

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%doc Changes README
%{perl_vendorlib}/MLDBM/
%{perl_vendorlib}/MLDBM.pm
%{_mandir}/man3/MLDBM.3*

%changelog
* Wed Apr 26 2023 Paul Howarth <paul@city-fan.org> - 2.05-29
- Use SPDX-format license tag

* Sun Jun  2 2019 Paul Howarth <paul@city-fan.org> - 2.05-17
- Perl 5.30 rebuild

* Fri Apr 27 2018 Paul Howarth <paul@city-fan.org> - 2.05-13
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Mon Sep  5 2016 Paul Howarth <paul@city-fan.org> - 2.05-9
- Classify buildreqs by usage
- Simplify find command using -delete

* Thu Aug 28 2014 Paul Howarth <paul@city-fan.org> - 2.05-5
- Drop %%defattr, redundant since rpm 4.4

* Thu Feb 21 2013 Paul Howarth <paul@city-fan.org> - 2.05-1
- Update to 2.05
  - Require perl 5.5
  - Test for pod

* Sat Jun 23 2012 Paul Howarth <paul@city-fan.org> - 2.04-6
- BR: perl(Carp), perl(Data::Dumper) ≥ 2.08, perl(Storable)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Tue Jun 28 2011 Paul Howarth <paul@city-fan.org> - 2.04-4
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Thu Jun 24 2010 Paul Howarth <paul@city-fan.org> - 2.04-3
- Rebuild for perl 5.12.1 in Rawhide

* Fri May  7 2010 Paul Howarth <paul@city-fan.org> - 2.04-2
- Fix dist tag to work with RHEL6 Beta

* Mon Mar  8 2010 Paul Howarth <paul@city-fan.org> - 2.04-1
- Update to 2.04 (fix for old EU::MM)
- Drop upstreamed patch

* Mon Mar  1 2010 Paul Howarth <paul@city-fan.org> - 2.03-1
- Update to 2.03 (t/storable_dbfile.t fixed, switch to Module::Build)
- Upstream distribution is back to being a tarball
- Drop upstreamed patch
- Add new patch to work around Module::Build issues on old distributions

* Mon Feb 22 2010 Paul Howarth <paul@city-fan.org> - 2.02-1
- Update to 2.02 (new tests added, distribution upgraded)
- New upstream maintainer -> new source URL
- Upstream distribution is now a zipfile - ugh!
- Add buildreq perl(Test::More)
- Add patch to fix t/storable_dbfile.t for old Test::More versions
- Dist tag for Rawhide no longer needs special-casing
- Use %%{_fixperms} macro instead of our own %%{__chmod} incantation

* Mon Sep 21 2009 Paul Howarth <paul@city-fan.org> - 2.01-7
- Define RPM macros in global scope

* Sat Nov  1 2008 Paul Howarth <paul@city-fan.org> 2.01-6
- Tweak dist tag macros to work on current Rawhide with three-part releasenum
- Clarify license as GPL version 1 or later, or Artistic (i.e. same as perl)

* Mon Mar 19 2007 Paul Howarth <paul@city-fan.org> - 2.01-5
- Fix dist tag for development releases and Fedora 7 onwards
- Remove %%{__perl_version} macro, used only once
- Remove %%{__perl_package} macro, used only twice
- Remove buildroot unconditionally in %%clean and %%install
- Don't use macros in command paths, hardcode them instead
- Fix argument order for find with -depth
- Use search.cpan.org URLs
- BuildRequire perl(ExtUtils::MakeMaker)
- Define %%{__id_u} in a more portable way

* Tue Jul 12 2005 Paul Howarth <paul@city-fan.org> - 2.01-4
- Rewrite spec file in (mainly) Fedora Extras style
- Include full URL for source
- Fix URL
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Remove MANIFEST from %%doc

* Thu May  5 2005 Paul Howarth <paul@city-fan.org> - 2.01-3
- Tidy up spec file

* Wed Apr 14 2004 Paul Howarth <paul@city-fan.org> - 2.01-2
- Added explicit perl dependency to ensure that an RPM built on a
  system with an updated version of perl (and hence having files
  installed in a place that a non-updated system won't find them)
  will not install on the non-updated system; in such cases, just
  rebuilt from the source RPM
- Changed distribution-identifying macros for greater portability

* Wed Feb 18 2004 Paul Howarth <paul@city-fan.org> - 2.01-1
- Initial build
